
(require* OntologyTransformation)


;;;Search for predicates that contain "CanCause".
(defquery search-by-predicate
  "Finds triples with hasbase predicate"
  (declare (variables ?predicate))
  (triple (predicate ?predicate) (subject ?subject) (object ?object)))

;;;Each ontology document can be accessed via an IRI 
;;;The "IRI" part of the related ontology "http://www.owl-ontologies.com/2010/Ontology1270064149.owl" should be entered here:
(bind ?result (run-query* search-by-predicate (str-cat "http://www.owl-ontologies.com/2010/Ontology1270064149.owl" "#CanCause" )))


			;;;New facts are asserted (triple template converts to the event_route template, in order to be able to perform forward chaining)
			;;;triple template:
			;;;(deftemplate triple "Template representing a triple" 
			;;;   (slot predicate (default "")) 
			;;;   (slot subject   (default "")) 
			;;;   (slot object    (default ""))
			;;;)
			;;;
			;;;event_route template:
			;;;(deftemplate event_route "Template representing an event route" 
			;;;   (slot from) 
			;;;   (slot to)
			;;;)

(deftemplate event_route1 (slot from1) (slot to1))
(while (?result next)
         (assert (event_route1 (from1 (?result getString subject)) (to1 (?result getString object)))))
      

;;;Asserted facts from the ontology are in the IRI format, therefore the "Event" keywords should be extracted from it.
(deftemplate event_route (slot from)(slot to))
(defrule upgrade_routes
 ?R <- (event_route1 (from1 ?a)(to1 ?b))
 =>
   (retract ?R)    ;we remove "event_route1" facts and replace "event_route" facts with required keywords.
   (assert (event_route 
                  (from (sub-string (+ (str-index "#" ?a) 1) (str-length ?a) ?a))
                  (to (sub-string (+ (str-index "#" ?b) 1) (str-length ?b) ?b)))
            )
    )
;(reset)
(run)
;(facts)
;;; EOF